poj 3126 BFS

36 篇文章 0 订阅

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 14323 Accepted: 8080

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source

题意:将数a变出数b.每次都变换一位数使变换后的数为素数,看最少需要变换几次

#include<iostream>
#include<cstdio>
#include<cstring>
#include<queue>
#include<algorithm>
#include<cmath>

using namespace std;

queue<int>Q;
int vis[10000];
int used[10000];
int step[10000];
int Build()    //素数筛
{
    int n=10000;
    memset(vis,0,sizeof(vis));
    int m=sqrt(n+0.5);
    for(int i=2; i<=m; i++)
        if(!vis[i])
            for(int j=i*i; j<=n; j+=i)
                vis[j]=1;
}
int p;
int BFS(int a,int b)
{
    while(!Q.empty()) //清空
        Q.pop();
        
    Q.push(a);
    used[a]=1;
    step[a]=0;
    while(!Q.empty())
    {
        p=Q.front();
        Q.pop();
        for(int i=0; i<4; i++)
        {
            if(i==0)     //个位
            {
                for(int j=0; j<=9; j++)
                {
                    int x=p/10*10+j;
                    if(vis[x])
                        continue;
                    if(used[x]==0)
                    {
                        used[x]=1;
                        step[x]=step[p]+1;
                        Q.push(x);
                    }
                    if(x==b)
                        return step[x];
                }
            }
            if(i==1)    //十位
            {
                for(int j=0; j<=9; j++)
                {
                    int y=p%10;
                    int x=p/100*100+j*10+y;
                    if(vis[x])
                        continue;
                    if(used[x]==0)
                    {
                        used[x]=1;
                        step[x]=step[p]+1;
                        Q.push(x);
                    }
                    if(x==b)
                        return step[x];
                }
            }
            if(i==2)             //百位
            {
                for(int j=0; j<=9; j++)
                {
                    int y=p%100;
                    int x=p/1000*1000+j*100+y;
                    if(vis[x])
                        continue;
                    if(used[x]==0)
                    {
                        used[x]=1;
                        step[x]=step[p]+1;
                        Q.push(x);
                    }
                    if(x==b)
                        return step[x];
                }
            }
            if(i==3)            //千位<span id="transmark"></span>
            {
                for(int j=1; j<=9; j++)                                   //必须从1开始
                {
                    int y=p%1000;
                    int x=j*1000+y;
                    if(vis[x])
                        continue;
                    if(used[x]==0)
                    {
                        used[x]=1;
                        step[x]=step[p]+1;
                        Q.push(x);
                    }
                    if(x==b)
                        return step[x];
                }
            }
        }
    }
}
int main()
{
    Build();
    int a,b,n;
    while(~scanf("%d",&n))
    {
        while(n--)
        {
            memset(used,0,sizeof(used));
            scanf("%d%d",&a,&b);
            printf("%d\n", BFS(a,b));
        }
    }
}



评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值